﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Generator.Test.TestReference
{


    /// <summary>
    /// Data transfer object for the request of the Accelerate To command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class AccelerateToRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {

        private Tecan.Sila2.RealDto _target;

        private Tecan.Sila2.RealDto _maxAcceleration;

        private Tecan.Sila2.RealDto _timeRange;

        /// <summary>
        /// Create a new instance
        /// </summary>
        public AccelerateToRequestDto()
        {
        }

        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="target">The speed to reach</param>
        /// <param name="timeRange">The time in which to reach the speed</param>
        public AccelerateToRequestDto( double target, double maxAcceleration, double timeRange, Tecan.Sila2.IBinaryStore store )
        {
            Target = new Tecan.Sila2.RealDto( target, store );
            MaxAcceleration = new Tecan.Sila2.RealDto( maxAcceleration, store );
            TimeRange = new Tecan.Sila2.RealDto( timeRange, store );
        }

        /// <summary>
        /// The speed to reach
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute( 1 )]
        public Tecan.Sila2.RealDto Target
        {
            get
            {
                return _target;
            }
            set
            {
                _target = value;
            }
        }

        [ProtoBuf.ProtoMemberAttribute( 2 )]
        public Tecan.Sila2.RealDto MaxAcceleration
        {
            get
            {
                return _maxAcceleration;
            }
            set
            {
                _maxAcceleration = value;
            }
        }

        /// <summary>
        /// The time in which to reach the speed
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute( 3 )]
        public Tecan.Sila2.RealDto TimeRange
        {
            get
            {
                return _timeRange;
            }
            set
            {
                _timeRange = value;
            }
        }

        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "tecan.sila.generator.test/testreference/ConfiguredService/v4/Command/AccelerateTo" +
                    "";
            }
        }

        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate( Target, "target" );
            Argument.Validate( MaxAcceleration, "maxAcceleration" );
            Argument.Validate( TimeRange, "timeRange" );
        }

        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ((("" + Argument.Require( Target, "target" ))
                        + Argument.Require( MaxAcceleration, "maxAcceleration" ))
                        + Argument.Require( TimeRange, "timeRange" ));
        }
    }

    /// <summary>
    /// Data transfer object to encapsulate the response of the Speed property
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class SpeedResponseDto : Tecan.Sila2.ISilaTransferObject
    {

        private Tecan.Sila2.RealDto _value;

        /// <summary>
        /// Create a new instance
        /// </summary>
        public SpeedResponseDto()
        {
        }

        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public SpeedResponseDto( double value, Tecan.Sila2.IBinaryStore store )
        {
            Value = new Tecan.Sila2.RealDto( value, store );
        }

        /// <summary>
        /// The  property
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute( 1 )]
        public Tecan.Sila2.RealDto Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
            }
        }

        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate( Value, "value" );
        }

        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require( Value, "value" ));
        }
    }
}
